/* Settings.c generated by valac 0.56.8, the Vala compiler
 * generated from Settings.vala, do not modify */

/* Settings.vala
 *
 * The following code is a derivative work of the code from
 * https://github.com/elementary/granite/blob/master/lib/Services/Settings.vala
 * which is licensed under GNU Lesser General Public version 3 of the License,
 * or (at your option) any later version.
 *
 * Copyright 2020 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "marble.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

enum  {
	MARBLE_SETTINGS_0_PROPERTY,
	MARBLE_SETTINGS_SCHEMA_PROPERTY,
	MARBLE_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* marble_settings_properties[MARBLE_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MarbleSettingsPrivate {
	GSettings* _schema;
	gboolean updating;
	gboolean doing_setup;
};

static gint MarbleSettings_private_offset;
static gpointer marble_settings_parent_class = NULL;

static void marble_settings_load_key (MarbleSettings* self,
                               const gchar* key);
static void marble_settings_on_notify (MarbleSettings* self,
                                GObject* sender,
                                GParamSpec* prop);
static void _marble_settings_on_notify_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static void marble_settings_save_key (MarbleSettings* self,
                               const gchar* key);
static GObject * marble_settings_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _marble_settings_load_key_g_settings_changed (GSettings* _sender,
                                                   const gchar* key,
                                                   gpointer self);
static void marble_settings_finalize (GObject * obj);
static GType marble_settings_get_type_once (void);
static void _vala_marble_settings_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_marble_settings_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
marble_settings_get_instance_private (MarbleSettings* self)
{
	return G_STRUCT_MEMBER_P (self, MarbleSettings_private_offset);
}

MarbleSettings*
marble_settings_construct (GType object_type,
                           const gchar* path)
{
	MarbleSettings * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = g_settings_new (path);
	_tmp1_ = _tmp0_;
	self = (MarbleSettings*) g_object_new (object_type, "schema", _tmp1_, NULL);
	_g_object_unref0 (_tmp1_);
	return self;
}

static gpointer
_g_param_spec_ref0 (gpointer self)
{
	return self ? g_param_spec_ref (self) : NULL;
}

static void
_marble_settings_on_notify_g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
	marble_settings_on_notify ((MarbleSettings*) self, _sender, pspec);
}

static void
marble_settings_load_key (MarbleSettings* self,
                          const gchar* key)
{
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp0_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp1_;
	GParamSpec* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp4_;
	guint _tmp5_;
	GType type = 0UL;
	GParamSpec* _tmp6_;
	GValue val = {0};
	GValue _tmp7_ = {0};
	GParamSpec* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (key, "schema") == 0) {
		return;
	}
	_tmp0_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
	obj_class = (GObjectClass*) _tmp0_;
	_tmp1_ = obj_class;
	_tmp2_ = g_object_class_find_property (_tmp1_, key);
	_tmp3_ = _g_param_spec_ref0 (_tmp2_);
	prop = _tmp3_;
	_tmp4_ = prop;
	if (_tmp4_ == NULL) {
		_g_param_spec_unref0 (prop);
		_g_type_class_unref0 (obj_class);
		return;
	}
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _marble_settings_on_notify_g_object_notify, self);
	_tmp6_ = prop;
	type = _tmp6_->value_type;
	g_value_init (&_tmp7_, type);
	val = _tmp7_;
	g_object_get_property ((GObject*) self, key, &val);
	_tmp8_ = prop;
	if (G_VALUE_TYPE (&val) == _tmp8_->value_type) {
		if (type == G_TYPE_INT) {
			GParamSpec* _tmp9_;
			const gchar* _tmp10_;
			GSettings* _tmp11_;
			GValue _tmp12_ = {0};
			_tmp9_ = prop;
			_tmp10_ = _tmp9_->name;
			_tmp11_ = self->priv->_schema;
			g_value_init (&_tmp12_, G_TYPE_INT);
			g_value_set_int (&_tmp12_, g_settings_get_int (_tmp11_, key));
			g_object_set_property ((GObject*) self, _tmp10_, &_tmp12_);
			G_IS_VALUE (&_tmp12_) ? (g_value_unset (&_tmp12_), NULL) : NULL;
		} else {
			if (type == G_TYPE_UINT) {
				GParamSpec* _tmp13_;
				const gchar* _tmp14_;
				GSettings* _tmp15_;
				GValue _tmp16_ = {0};
				_tmp13_ = prop;
				_tmp14_ = _tmp13_->name;
				_tmp15_ = self->priv->_schema;
				g_value_init (&_tmp16_, G_TYPE_UINT);
				g_value_set_uint (&_tmp16_, g_settings_get_uint (_tmp15_, key));
				g_object_set_property ((GObject*) self, _tmp14_, &_tmp16_);
				G_IS_VALUE (&_tmp16_) ? (g_value_unset (&_tmp16_), NULL) : NULL;
			} else {
				if (type == G_TYPE_DOUBLE) {
					GParamSpec* _tmp17_;
					const gchar* _tmp18_;
					GSettings* _tmp19_;
					GValue _tmp20_ = {0};
					_tmp17_ = prop;
					_tmp18_ = _tmp17_->name;
					_tmp19_ = self->priv->_schema;
					g_value_init (&_tmp20_, G_TYPE_DOUBLE);
					g_value_set_double (&_tmp20_, g_settings_get_double (_tmp19_, key));
					g_object_set_property ((GObject*) self, _tmp18_, &_tmp20_);
					G_IS_VALUE (&_tmp20_) ? (g_value_unset (&_tmp20_), NULL) : NULL;
				} else {
					if (type == G_TYPE_BOOLEAN) {
						GParamSpec* _tmp21_;
						const gchar* _tmp22_;
						GSettings* _tmp23_;
						GValue _tmp24_ = {0};
						_tmp21_ = prop;
						_tmp22_ = _tmp21_->name;
						_tmp23_ = self->priv->_schema;
						g_value_init (&_tmp24_, G_TYPE_BOOLEAN);
						g_value_set_boolean (&_tmp24_, g_settings_get_boolean (_tmp23_, key));
						g_object_set_property ((GObject*) self, _tmp22_, &_tmp24_);
						G_IS_VALUE (&_tmp24_) ? (g_value_unset (&_tmp24_), NULL) : NULL;
					} else {
						if (type == G_TYPE_STRING) {
							GParamSpec* _tmp25_;
							const gchar* _tmp26_;
							GSettings* _tmp27_;
							gchar* _tmp28_;
							GValue _tmp29_ = {0};
							_tmp25_ = prop;
							_tmp26_ = _tmp25_->name;
							_tmp27_ = self->priv->_schema;
							_tmp28_ = g_settings_get_string (_tmp27_, key);
							g_value_init (&_tmp29_, G_TYPE_STRING);
							g_value_take_string (&_tmp29_, _tmp28_);
							g_object_set_property ((GObject*) self, _tmp26_, &_tmp29_);
							G_IS_VALUE (&_tmp29_) ? (g_value_unset (&_tmp29_), NULL) : NULL;
						} else {
							if (type == G_TYPE_STRV) {
								GParamSpec* _tmp30_;
								const gchar* _tmp31_;
								GSettings* _tmp32_;
								gchar** _tmp33_;
								gchar** _tmp34_;
								GValue _tmp35_ = {0};
								_tmp30_ = prop;
								_tmp31_ = _tmp30_->name;
								_tmp32_ = self->priv->_schema;
								_tmp34_ = _tmp33_ = g_settings_get_strv (_tmp32_, key);
								g_value_init (&_tmp35_, G_TYPE_STRV);
								g_value_take_boxed (&_tmp35_, _tmp34_);
								g_object_set_property ((GObject*) self, _tmp31_, &_tmp35_);
								G_IS_VALUE (&_tmp35_) ? (g_value_unset (&_tmp35_), NULL) : NULL;
							} else {
								if (type == G_TYPE_INT64) {
									GParamSpec* _tmp36_;
									const gchar* _tmp37_;
									GSettings* _tmp38_;
									GVariant* _tmp39_;
									GVariant* _tmp40_;
									GValue _tmp41_ = {0};
									_tmp36_ = prop;
									_tmp37_ = _tmp36_->name;
									_tmp38_ = self->priv->_schema;
									_tmp39_ = g_settings_get_value (_tmp38_, key);
									_tmp40_ = _tmp39_;
									g_value_init (&_tmp41_, G_TYPE_INT64);
									g_value_set_int64 (&_tmp41_, g_variant_get_int64 (_tmp40_));
									g_object_set_property ((GObject*) self, _tmp37_, &_tmp41_);
									G_IS_VALUE (&_tmp41_) ? (g_value_unset (&_tmp41_), NULL) : NULL;
									_g_variant_unref0 (_tmp40_);
								} else {
									if (type == G_TYPE_UINT64) {
										GParamSpec* _tmp42_;
										const gchar* _tmp43_;
										GSettings* _tmp44_;
										GVariant* _tmp45_;
										GVariant* _tmp46_;
										GValue _tmp47_ = {0};
										_tmp42_ = prop;
										_tmp43_ = _tmp42_->name;
										_tmp44_ = self->priv->_schema;
										_tmp45_ = g_settings_get_value (_tmp44_, key);
										_tmp46_ = _tmp45_;
										g_value_init (&_tmp47_, G_TYPE_UINT64);
										g_value_set_uint64 (&_tmp47_, g_variant_get_uint64 (_tmp46_));
										g_object_set_property ((GObject*) self, _tmp43_, &_tmp47_);
										G_IS_VALUE (&_tmp47_) ? (g_value_unset (&_tmp47_), NULL) : NULL;
										_g_variant_unref0 (_tmp46_);
									} else {
										if (G_TYPE_IS_ENUM (type)) {
											GParamSpec* _tmp48_;
											const gchar* _tmp49_;
											GSettings* _tmp50_;
											GValue _tmp51_ = {0};
											_tmp48_ = prop;
											_tmp49_ = _tmp48_->name;
											_tmp50_ = self->priv->_schema;
											g_value_init (&_tmp51_, G_TYPE_INT);
											g_value_set_int (&_tmp51_, g_settings_get_enum (_tmp50_, key));
											g_object_set_property ((GObject*) self, _tmp49_, &_tmp51_);
											G_IS_VALUE (&_tmp51_) ? (g_value_unset (&_tmp51_), NULL) : NULL;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	} else {
		gchar* _tmp52_;
		gchar* _tmp53_;
		_tmp52_ = g_strdup_printf ("%lu", (gulong) type);
		_tmp53_ = _tmp52_;
		g_warning ("Settings.vala:93: Unsuported type %s for key %s", _tmp53_, key);
		_g_free0 (_tmp53_);
	}
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _marble_settings_on_notify_g_object_notify, self, 0);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	_g_param_spec_unref0 (prop);
	_g_type_class_unref0 (obj_class);
}

static void
marble_settings_save_key (MarbleSettings* self,
                          const gchar* key)
{
	gboolean _tmp0_ = FALSE;
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp1_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp4_;
	GParamSpec* _tmp5_;
	guint _tmp6_;
	gboolean res = FALSE;
	GType type = 0UL;
	GParamSpec* _tmp7_;
	GValue val = {0};
	GValue _tmp8_ = {0};
	GParamSpec* _tmp9_;
	const gchar* _tmp10_;
	GParamSpec* _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (key, "schema") == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->updating;
	}
	if (_tmp0_) {
		return;
	}
	_tmp1_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
	obj_class = (GObjectClass*) _tmp1_;
	_tmp2_ = obj_class;
	_tmp3_ = g_object_class_find_property (_tmp2_, key);
	_tmp4_ = _g_param_spec_ref0 (_tmp3_);
	prop = _tmp4_;
	_tmp5_ = prop;
	if (_tmp5_ == NULL) {
		_g_param_spec_unref0 (prop);
		_g_type_class_unref0 (obj_class);
		return;
	}
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp6_, NULL, FALSE);
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _marble_settings_on_notify_g_object_notify, self);
	res = TRUE;
	self->priv->updating = TRUE;
	_tmp7_ = prop;
	type = _tmp7_->value_type;
	g_value_init (&_tmp8_, type);
	val = _tmp8_;
	_tmp9_ = prop;
	_tmp10_ = _tmp9_->name;
	g_object_get_property ((GObject*) self, _tmp10_, &val);
	_tmp11_ = prop;
	if (G_VALUE_TYPE (&val) == _tmp11_->value_type) {
		gboolean _tmp12_ = FALSE;
		if (type == G_TYPE_INT) {
			GSettings* _tmp13_;
			_tmp13_ = self->priv->_schema;
			_tmp12_ = g_value_get_int (&val) != g_settings_get_int (_tmp13_, key);
		} else {
			_tmp12_ = FALSE;
		}
		if (_tmp12_) {
			GSettings* _tmp14_;
			_tmp14_ = self->priv->_schema;
			res = g_settings_set_int (_tmp14_, key, g_value_get_int (&val));
		} else {
			gboolean _tmp15_ = FALSE;
			if (type == G_TYPE_UINT) {
				GSettings* _tmp16_;
				_tmp16_ = self->priv->_schema;
				_tmp15_ = g_value_get_uint (&val) != g_settings_get_uint (_tmp16_, key);
			} else {
				_tmp15_ = FALSE;
			}
			if (_tmp15_) {
				GSettings* _tmp17_;
				_tmp17_ = self->priv->_schema;
				res = g_settings_set_uint (_tmp17_, key, g_value_get_uint (&val));
			} else {
				gboolean _tmp18_ = FALSE;
				if (type == G_TYPE_DOUBLE) {
					GSettings* _tmp19_;
					_tmp19_ = self->priv->_schema;
					_tmp18_ = g_value_get_double (&val) != g_settings_get_double (_tmp19_, key);
				} else {
					_tmp18_ = FALSE;
				}
				if (_tmp18_) {
					GSettings* _tmp20_;
					_tmp20_ = self->priv->_schema;
					res = g_settings_set_double (_tmp20_, key, g_value_get_double (&val));
				} else {
					gboolean _tmp21_ = FALSE;
					if (type == G_TYPE_BOOLEAN) {
						GSettings* _tmp22_;
						_tmp22_ = self->priv->_schema;
						_tmp21_ = g_value_get_boolean (&val) != g_settings_get_boolean (_tmp22_, key);
					} else {
						_tmp21_ = FALSE;
					}
					if (_tmp21_) {
						GSettings* _tmp23_;
						_tmp23_ = self->priv->_schema;
						res = g_settings_set_boolean (_tmp23_, key, g_value_get_boolean (&val));
					} else {
						gboolean _tmp24_ = FALSE;
						if (type == G_TYPE_STRING) {
							const gchar* _tmp25_;
							GSettings* _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
							_tmp25_ = g_value_get_string (&val);
							_tmp26_ = self->priv->_schema;
							_tmp27_ = g_settings_get_string (_tmp26_, key);
							_tmp28_ = _tmp27_;
							_tmp24_ = g_strcmp0 (_tmp25_, _tmp28_) != 0;
							_g_free0 (_tmp28_);
						} else {
							_tmp24_ = FALSE;
						}
						if (_tmp24_) {
							GSettings* _tmp29_;
							const gchar* _tmp30_;
							_tmp29_ = self->priv->_schema;
							_tmp30_ = g_value_get_string (&val);
							res = g_settings_set_string (_tmp29_, key, _tmp30_);
						} else {
							if (type == G_TYPE_STRV) {
								gchar** strv = NULL;
								gint strv_length1;
								gint _strv_size_;
								gchar** _tmp31_;
								gint _tmp31__length1;
								GSettings* _tmp32_;
								gchar** _tmp33_;
								gchar** _tmp34_;
								gchar** _tmp35_;
								gint _tmp35__length1;
								gboolean _tmp36_;
								strv = NULL;
								strv_length1 = 0;
								_strv_size_ = strv_length1;
								g_object_get ((GObject*) self, key, &strv, NULL);
								_tmp31_ = strv;
								_tmp31__length1 = strv_length1;
								_tmp32_ = self->priv->_schema;
								_tmp34_ = _tmp33_ = g_settings_get_strv (_tmp32_, key);
								_tmp35_ = _tmp34_;
								_tmp35__length1 = _vala_array_length (_tmp33_);
								_tmp36_ = _tmp31_ != _tmp35_;
								_tmp35_ = (_vala_array_free (_tmp35_, _tmp35__length1, (GDestroyNotify) g_free), NULL);
								if (_tmp36_) {
									GSettings* _tmp37_;
									gchar** _tmp38_;
									gint _tmp38__length1;
									_tmp37_ = self->priv->_schema;
									_tmp38_ = strv;
									_tmp38__length1 = strv_length1;
									res = g_settings_set_strv (_tmp37_, key, _tmp38_);
								}
								strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
							} else {
								gboolean _tmp39_ = FALSE;
								if (type == G_TYPE_INT64) {
									GSettings* _tmp40_;
									GVariant* _tmp41_;
									GVariant* _tmp42_;
									_tmp40_ = self->priv->_schema;
									_tmp41_ = g_settings_get_value (_tmp40_, key);
									_tmp42_ = _tmp41_;
									_tmp39_ = g_value_get_int64 (&val) != g_variant_get_int64 (_tmp42_);
									_g_variant_unref0 (_tmp42_);
								} else {
									_tmp39_ = FALSE;
								}
								if (_tmp39_) {
									GSettings* _tmp43_;
									GVariant* _tmp44_;
									GVariant* _tmp45_;
									_tmp43_ = self->priv->_schema;
									_tmp44_ = g_variant_new_int64 (g_value_get_int64 (&val));
									g_variant_ref_sink (_tmp44_);
									_tmp45_ = _tmp44_;
									res = g_settings_set_value (_tmp43_, key, _tmp45_);
									_g_variant_unref0 (_tmp45_);
								} else {
									gboolean _tmp46_ = FALSE;
									if (type == G_TYPE_UINT64) {
										GSettings* _tmp47_;
										GVariant* _tmp48_;
										GVariant* _tmp49_;
										_tmp47_ = self->priv->_schema;
										_tmp48_ = g_settings_get_value (_tmp47_, key);
										_tmp49_ = _tmp48_;
										_tmp46_ = g_value_get_uint64 (&val) != g_variant_get_uint64 (_tmp49_);
										_g_variant_unref0 (_tmp49_);
									} else {
										_tmp46_ = FALSE;
									}
									if (_tmp46_) {
										GSettings* _tmp50_;
										GVariant* _tmp51_;
										GVariant* _tmp52_;
										_tmp50_ = self->priv->_schema;
										_tmp51_ = g_variant_new_uint64 (g_value_get_uint64 (&val));
										g_variant_ref_sink (_tmp51_);
										_tmp52_ = _tmp51_;
										res = g_settings_set_value (_tmp50_, key, _tmp52_);
										_g_variant_unref0 (_tmp52_);
									} else {
										gboolean _tmp53_ = FALSE;
										if (G_TYPE_IS_ENUM (type)) {
											GSettings* _tmp54_;
											_tmp54_ = self->priv->_schema;
											_tmp53_ = g_value_get_enum (&val) != g_settings_get_enum (_tmp54_, key);
										} else {
											_tmp53_ = FALSE;
										}
										if (_tmp53_) {
											GSettings* _tmp55_;
											_tmp55_ = self->priv->_schema;
											res = g_settings_set_enum (_tmp55_, key, g_value_get_enum (&val));
										}
									}
								}
							}
						}
					}
				}
			}
		}
	} else {
		gchar* _tmp56_;
		gchar* _tmp57_;
		_tmp56_ = g_strdup_printf ("%lu", (gulong) type);
		_tmp57_ = _tmp56_;
		g_warning ("Settings.vala:175: Unsuported type %s for key %s", _tmp57_, key);
		_g_free0 (_tmp57_);
	}
	if (!res) {
		g_warning ("Settings.vala:179: Could not update %s", key);
	}
	self->priv->updating = FALSE;
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _marble_settings_on_notify_g_object_notify, self, 0);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	_g_param_spec_unref0 (prop);
	_g_type_class_unref0 (obj_class);
}

static void
marble_settings_on_notify (MarbleSettings* self,
                           GObject* sender,
                           GParamSpec* prop)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (prop != NULL);
	_tmp0_ = prop->name;
	marble_settings_save_key (self, _tmp0_);
}

GSettings*
marble_settings_get_schema (MarbleSettings* self)
{
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_schema;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
marble_settings_set_schema (MarbleSettings* self,
                            GSettings* value)
{
	GSettings* old_value;
	g_return_if_fail (self != NULL);
	old_value = marble_settings_get_schema (self);
	if (old_value != value) {
		GSettings* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_schema);
		self->priv->_schema = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, marble_settings_properties[MARBLE_SETTINGS_SCHEMA_PROPERTY]);
	}
}

static void
_marble_settings_load_key_g_settings_changed (GSettings* _sender,
                                              const gchar* key,
                                              gpointer self)
{
	marble_settings_load_key ((MarbleSettings*) self, key);
}

static GObject *
marble_settings_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MarbleSettings * self;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp4_;
	GParamSpec** properties = NULL;
	GObjectClass* _tmp5_;
	guint _tmp6_ = 0;
	GParamSpec** _tmp7_;
	gint properties_length1;
	gint _properties_size_;
	GParamSpec** _tmp8_;
	gint _tmp8__length1;
	GSettings* _tmp11_;
	parent_class = G_OBJECT_CLASS (marble_settings_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARBLE_TYPE_SETTINGS, MarbleSettings);
	_tmp0_ = self->priv->_schema;
	g_object_get (_tmp0_, "schema-id", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	g_debug ("Settings.vala:41: Started settings from '%s'", _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
	obj_class = (GObjectClass*) _tmp4_;
	_tmp5_ = obj_class;
	_tmp7_ = g_object_class_list_properties (_tmp5_, &_tmp6_);
	properties = _tmp7_;
	properties_length1 = _tmp6_;
	_properties_size_ = properties_length1;
	_tmp8_ = properties;
	_tmp8__length1 = properties_length1;
	{
		GParamSpec** prop_collection = NULL;
		gint prop_collection_length1 = 0;
		gint _prop_collection_size_ = 0;
		gint prop_it = 0;
		prop_collection = _tmp8_;
		prop_collection_length1 = _tmp8__length1;
		for (prop_it = 0; prop_it < prop_collection_length1; prop_it = prop_it + 1) {
			GParamSpec* prop = NULL;
			prop = prop_collection[prop_it];
			{
				GParamSpec* _tmp9_;
				const gchar* _tmp10_;
				_tmp9_ = prop;
				_tmp10_ = _tmp9_->name;
				marble_settings_load_key (self, _tmp10_);
			}
		}
	}
	self->priv->doing_setup = FALSE;
	_tmp11_ = self->priv->_schema;
	g_signal_connect_object (_tmp11_, "changed", (GCallback) _marble_settings_load_key_g_settings_changed, self, 0);
	properties = (g_free (properties), NULL);
	_g_type_class_unref0 (obj_class);
	return obj;
}

static void
marble_settings_class_init (MarbleSettingsClass * klass,
                            gpointer klass_data)
{
	marble_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MarbleSettings_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_marble_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_marble_settings_set_property;
	G_OBJECT_CLASS (klass)->constructor = marble_settings_constructor;
	G_OBJECT_CLASS (klass)->finalize = marble_settings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MARBLE_SETTINGS_SCHEMA_PROPERTY, marble_settings_properties[MARBLE_SETTINGS_SCHEMA_PROPERTY] = g_param_spec_object ("schema", "schema", "schema", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}

static void
marble_settings_instance_init (MarbleSettings * self,
                               gpointer klass)
{
	self->priv = marble_settings_get_instance_private (self);
	self->priv->updating = FALSE;
	self->priv->doing_setup = TRUE;
}

static void
marble_settings_finalize (GObject * obj)
{
	MarbleSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARBLE_TYPE_SETTINGS, MarbleSettings);
	_g_object_unref0 (self->priv->_schema);
	G_OBJECT_CLASS (marble_settings_parent_class)->finalize (obj);
}

static GType
marble_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MarbleSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) marble_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MarbleSettings), 0, (GInstanceInitFunc) marble_settings_instance_init, NULL };
	GType marble_settings_type_id;
	marble_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "MarbleSettings", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MarbleSettings_private_offset = g_type_add_instance_private (marble_settings_type_id, sizeof (MarbleSettingsPrivate));
	return marble_settings_type_id;
}

GType
marble_settings_get_type (void)
{
	static volatile gsize marble_settings_type_id__once = 0;
	if (g_once_init_enter (&marble_settings_type_id__once)) {
		GType marble_settings_type_id;
		marble_settings_type_id = marble_settings_get_type_once ();
		g_once_init_leave (&marble_settings_type_id__once, marble_settings_type_id);
	}
	return marble_settings_type_id__once;
}

static void
_vala_marble_settings_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	MarbleSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MARBLE_TYPE_SETTINGS, MarbleSettings);
	switch (property_id) {
		case MARBLE_SETTINGS_SCHEMA_PROPERTY:
		g_value_set_object (value, marble_settings_get_schema (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_marble_settings_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	MarbleSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MARBLE_TYPE_SETTINGS, MarbleSettings);
	switch (property_id) {
		case MARBLE_SETTINGS_SCHEMA_PROPERTY:
		marble_settings_set_schema (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

