/* Utils.c generated by valac 0.56.8, the Vala compiler
 * generated from Utils.vala, do not modify */

/* Utils.vala
 *
 * Copyright 2019 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "marble.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

GtkCssProvider*
marble_get_css_provider_for_data (const gchar* data)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GError* _inner_error0_ = NULL;
	GtkCssProvider* result;
	g_return_val_if_fail (data != NULL, NULL);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	{
		GtkCssProvider* _tmp1_;
		_tmp1_ = provider;
		gtk_css_provider_load_from_data (_tmp1_, data, (gssize) -1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_warning ("Utils.vala:39: %s", _tmp3_);
		result = NULL;
		_g_error_free0 (e);
		_g_object_unref0 (provider);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (provider);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = provider;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
marble_set_theming_for_data (GtkWidget* widget,
                             const gchar* data,
                             const gchar* class_name,
                             gint priority)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkCssProvider* _tmp3_;
	g_return_if_fail (widget != NULL);
	g_return_if_fail (data != NULL);
	_tmp0_ = marble_get_css_provider_for_data (data);
	provider = _tmp0_;
	_tmp1_ = gtk_widget_get_style_context (widget);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	ctx = _tmp2_;
	_tmp3_ = provider;
	if (_tmp3_ != NULL) {
		GtkStyleContext* _tmp4_;
		GtkCssProvider* _tmp5_;
		_tmp4_ = ctx;
		_tmp5_ = provider;
		gtk_style_context_add_provider (_tmp4_, (GtkStyleProvider*) _tmp5_, (guint) priority);
	}
	if (class_name != NULL) {
		GtkStyleContext* _tmp6_;
		_tmp6_ = ctx;
		gtk_style_context_add_class (_tmp6_, class_name);
	}
	_g_object_unref0 (ctx);
	_g_object_unref0 (provider);
}

void
marble_add_css_provider_from_resource (const gchar* resource,
                                       gint priority,
                                       GdkScreen* screen)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	g_return_if_fail (resource != NULL);
	g_return_if_fail (screen != NULL);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	gtk_css_provider_load_from_resource (provider, resource);
	gtk_style_context_add_provider_for_screen (screen, (GtkStyleProvider*) provider, (guint) priority);
	_g_object_unref0 (provider);
}

