/* Loadable.c generated by valac 0.56.8, the Vala compiler
 * generated from Loadable.vala, do not modify */

/* Loadable.vala
 *
 * Copyright 2019 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "marble.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#define MARBLE_LOADABLE_DEFAULT_STYLE "\n" \
"        .loadable > spinner {\n" \
"            background: alpha(darker(@theme_bg_color), .6);\n" \
"        }\n" \
"    "

enum  {
	MARBLE_LOADABLE_0_PROPERTY,
	MARBLE_LOADABLE_LOADING_PROPERTY,
	MARBLE_LOADABLE_NUM_PROPERTIES
};
static GParamSpec* marble_loadable_properties[MARBLE_LOADABLE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MarbleLoadablePrivate {
	gboolean _loading;
	GtkSpinner* spinner;
};

static gint MarbleLoadable_private_offset;
static gpointer marble_loadable_parent_class = NULL;

static void marble_loadable_loading_changed (MarbleLoadable* self);
static void _marble_loadable_loading_changed_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void marble_loadable_finalize (GObject * obj);
static GType marble_loadable_get_type_once (void);
static void _vala_marble_loadable_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_marble_loadable_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
marble_loadable_get_instance_private (MarbleLoadable* self)
{
	return G_STRUCT_MEMBER_P (self, MarbleLoadable_private_offset);
}

/**
     * Creates a new {@link Marble.Loadable}.
     */
static void
_marble_loadable_loading_changed_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
	marble_loadable_loading_changed ((MarbleLoadable*) self);
}

MarbleLoadable*
marble_loadable_construct (GType object_type)
{
	MarbleLoadable * self = NULL;
	GtkSpinner* _tmp0_;
	GtkSpinner* _tmp1_;
	GtkSpinner* _tmp2_;
	GtkSpinner* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkSpinner* _tmp5_;
	self = (MarbleLoadable*) g_object_new (object_type, NULL);
	_tmp0_ = (GtkSpinner*) gtk_spinner_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->spinner);
	self->priv->spinner = _tmp0_;
	_tmp1_ = self->priv->spinner;
	gtk_spinner_start (_tmp1_);
	_tmp2_ = self->priv->spinner;
	gtk_overlay_add_overlay ((GtkOverlay*) self, (GtkWidget*) _tmp2_);
	_tmp3_ = self->priv->spinner;
	gtk_overlay_set_overlay_pass_through ((GtkOverlay*) self, (GtkWidget*) _tmp3_, FALSE);
	g_signal_connect_object ((GObject*) self, "notify::loading", (GCallback) _marble_loadable_loading_changed_g_object_notify, self, 0);
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp4_, "loadable");
	_tmp5_ = self->priv->spinner;
	marble_set_theming_for_data ((GtkWidget*) _tmp5_, MARBLE_LOADABLE_DEFAULT_STYLE, NULL, GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	return self;
}

MarbleLoadable*
marble_loadable_new (void)
{
	return marble_loadable_construct (MARBLE_TYPE_LOADABLE);
}

static void
marble_loadable_loading_changed (MarbleLoadable* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_loading;
	if (_tmp0_) {
		GtkSpinner* _tmp1_;
		_tmp1_ = self->priv->spinner;
		gtk_widget_show ((GtkWidget*) _tmp1_);
	} else {
		GtkSpinner* _tmp2_;
		_tmp2_ = self->priv->spinner;
		gtk_widget_hide ((GtkWidget*) _tmp2_);
	}
}

gboolean
marble_loadable_get_loading (MarbleLoadable* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_loading;
	return result;
}

void
marble_loadable_set_loading (MarbleLoadable* self,
                             gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = marble_loadable_get_loading (self);
	if (old_value != value) {
		self->priv->_loading = value;
		g_object_notify_by_pspec ((GObject *) self, marble_loadable_properties[MARBLE_LOADABLE_LOADING_PROPERTY]);
	}
}

static void
marble_loadable_class_init (MarbleLoadableClass * klass,
                            gpointer klass_data)
{
	marble_loadable_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MarbleLoadable_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_marble_loadable_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_marble_loadable_set_property;
	G_OBJECT_CLASS (klass)->finalize = marble_loadable_finalize;
	/**
	     * Whether or not the widget is working. ``False`` by default.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), MARBLE_LOADABLE_LOADING_PROPERTY, marble_loadable_properties[MARBLE_LOADABLE_LOADING_PROPERTY] = g_param_spec_boolean ("loading", "loading", "loading", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
marble_loadable_instance_init (MarbleLoadable * self,
                               gpointer klass)
{
	self->priv = marble_loadable_get_instance_private (self);
	self->priv->_loading = FALSE;
}

static void
marble_loadable_finalize (GObject * obj)
{
	MarbleLoadable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARBLE_TYPE_LOADABLE, MarbleLoadable);
	_g_object_unref0 (self->priv->spinner);
	G_OBJECT_CLASS (marble_loadable_parent_class)->finalize (obj);
}

/**
 * Loadable is a {@link Gtk.Overlay} that allows you to quickly toggle an
 * overlayed {@link Gtk.Spinner} on top of it's content. Useful when you run
 * async operations and need to let the user know something is being done in the
 * background.
 */
static GType
marble_loadable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MarbleLoadableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) marble_loadable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MarbleLoadable), 0, (GInstanceInitFunc) marble_loadable_instance_init, NULL };
	GType marble_loadable_type_id;
	marble_loadable_type_id = g_type_register_static (gtk_overlay_get_type (), "MarbleLoadable", &g_define_type_info, 0);
	MarbleLoadable_private_offset = g_type_add_instance_private (marble_loadable_type_id, sizeof (MarbleLoadablePrivate));
	return marble_loadable_type_id;
}

GType
marble_loadable_get_type (void)
{
	static volatile gsize marble_loadable_type_id__once = 0;
	if (g_once_init_enter (&marble_loadable_type_id__once)) {
		GType marble_loadable_type_id;
		marble_loadable_type_id = marble_loadable_get_type_once ();
		g_once_init_leave (&marble_loadable_type_id__once, marble_loadable_type_id);
	}
	return marble_loadable_type_id__once;
}

static void
_vala_marble_loadable_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	MarbleLoadable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MARBLE_TYPE_LOADABLE, MarbleLoadable);
	switch (property_id) {
		case MARBLE_LOADABLE_LOADING_PROPERTY:
		g_value_set_boolean (value, marble_loadable_get_loading (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_marble_loadable_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	MarbleLoadable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MARBLE_TYPE_LOADABLE, MarbleLoadable);
	switch (property_id) {
		case MARBLE_LOADABLE_LOADING_PROPERTY:
		marble_loadable_set_loading (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

